import { PathSegment } from '@sanity/types';
import { set, unset, setIfMissing, insert, inc, dec } from './patch/patches';
import type { Patch } from './patch/types';
declare type PatchArg = Patch | Patch[];
export default class PatchEvent {
    static from(...patches: PatchArg[]): PatchEvent;
    patches: Array<Patch>;
    constructor(patches: Array<Patch>);
    prepend(...patches: Array<PatchArg>): PatchEvent;
    append(...patches: Array<PatchArg>): PatchEvent;
    prefixAll(segment: PathSegment): PatchEvent;
}
export { PatchEvent, set, unset, setIfMissing, insert, inc, dec };
//# sourceMappingURL=PatchEvent.d.ts.map