import { Observable } from 'rxjs';
import { CrossDatasetReferenceInfo } from './types';
export declare type Loadable<T> = {
    isLoading: true;
    result: undefined;
    error: undefined;
    retry: () => void;
} | {
    isLoading: false;
    result: T;
    error: undefined;
    retry: () => void;
} | {
    isLoading: false;
    result: undefined;
    error: Error;
    retry: () => void;
};
declare type GetReferenceInfo = (doc: {
    _id: string;
    _type?: string;
}) => Observable<CrossDatasetReferenceInfo>;
export declare function useReferenceInfo(doc: {
    _id: string;
    _type?: string;
}, getReferenceInfo: GetReferenceInfo): Loadable<CrossDatasetReferenceInfo>;
export {};
//# sourceMappingURL=useReferenceInfo.d.ts.map