import React from 'react';
import { FormFieldPresence } from '@sanity/base/presence';
import { FormFieldSetProps } from '@sanity/base/components';
import { Marker, MultiFieldSet, Path } from '@sanity/types';
interface Props extends Omit<FormFieldSetProps, 'onFocus'> {
    fieldset: MultiFieldSet;
    focusPath: Path;
    onFocus: (focusPath: Path) => void;
    level: number;
    presence: FormFieldPresence[];
    markers: Marker[];
    fieldSetParent: Record<string, unknown> | undefined;
    fieldValues: Record<string, unknown>;
}
/**
 * A specialized component for object "fieldsets", e.g. a group of object fields as defined by the fieldsets option
 * on the object type https://www.sanity.io/docs/object-type#fieldsets-b8b5507db1d3
 */
export declare const ObjectFieldSet: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
export {};
//# sourceMappingURL=ObjectFieldSet.d.ts.map