import React from 'react';
import { FormFieldPresence } from '@sanity/base/presence';
import { ConditionalProperty, Marker, ObjectFieldType, Path, SchemaType } from '@sanity/types';
import PatchEvent from '../../PatchEvent';
interface FieldType {
    name: string;
    type: ObjectFieldType;
}
interface FieldProps {
    field: FieldType;
    parent: Record<string, unknown> | undefined;
    value: unknown;
    compareValue: unknown;
    onChange: (event: PatchEvent, field: FieldType) => void;
    onFocus: (path: Path) => void;
    onBlur: () => void;
    focusPath?: Path;
    filterField?: (type: SchemaType) => boolean;
    readOnly?: ConditionalProperty;
    markers?: Marker[];
    level: number;
    presence?: FormFieldPresence[];
}
export declare const ObjectInputField: React.ForwardRefExoticComponent<FieldProps & React.RefAttributes<any>>;
export {};
//# sourceMappingURL=ObjectInputField.d.ts.map