import { Observable } from 'rxjs';
import { ReferenceInfo } from './types';
export declare type Loadable<T> = {
    isLoading: true;
    result: undefined;
    error: undefined;
    retry: () => void;
} | {
    isLoading: false;
    result: T;
    error: undefined;
    retry: () => void;
} | {
    isLoading: false;
    result: undefined;
    error: Error;
    retry: () => void;
};
declare type GetReferenceInfo = (id: string) => Observable<ReferenceInfo>;
export declare function useReferenceInfo(id: string | undefined, getReferenceInfo: GetReferenceInfo): Loadable<ReferenceInfo>;
export {};
//# sourceMappingURL=useReferenceInfo.d.ts.map