import React from 'react';
export declare type FileInfo = {
    kind: DataTransferItem['kind'];
    type: DataTransferItem['type'];
};
declare type Props = {
    onFiles?: (files: File[]) => void;
    onFilesOver?: (files: FileInfo[]) => void;
    onFilesOut?: () => void;
    disabled?: boolean;
};
declare type ManagedProps = 'onDrop' | 'onDragOver' | 'onPaste' | 'onDragEnter' | 'onDragLeave' | 'onKeyDown';
/**
 * Higher order component that creates a file target from a given component.
 * Returns a component that acts both as a drop target and a paste target, emitting a list of Files upon drop or paste
 */
export declare function fileTarget<ComponentProps>(Component: React.ComponentType<ComponentProps>): React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<ComponentProps, ManagedProps> & Props> & React.RefAttributes<HTMLElement>>;
export {};
//# sourceMappingURL=fileTarget.d.ts.map