import React from 'react';
import { Path } from '@sanity/types';
import PropTypes from 'prop-types';
export interface WithValuePathProps {
    getValuePath: () => Path;
}
export default function withValuePath<T extends WithValuePathProps = WithValuePathProps>(ComposedComponent: React.ComponentType<T>): {
    new (props: Omit<T, "getValuePath"> | Readonly<Omit<T, "getValuePath">>): {
        _input: any;
        _didShowFocusWarning: boolean;
        focus(): void;
        setRef: (input: any) => void;
        render(): React.JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<Omit<T, "getValuePath">>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        readonly props: Readonly<Omit<T, "getValuePath">> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<Omit<T, "getValuePath">>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<Omit<T, "getValuePath">>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<Omit<T, "getValuePath">>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<Omit<T, "getValuePath">>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<Omit<T, "getValuePath">>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<Omit<T, "getValuePath">>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<Omit<T, "getValuePath">>, nextState: Readonly<{}>, nextContext: any): void;
    };
    new (props: Omit<T, "getValuePath">, context: any): {
        _input: any;
        _didShowFocusWarning: boolean;
        focus(): void;
        setRef: (input: any) => void;
        render(): React.JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<Omit<T, "getValuePath">>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        readonly props: Readonly<Omit<T, "getValuePath">> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<Omit<T, "getValuePath">>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<Omit<T, "getValuePath">>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<Omit<T, "getValuePath">>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<Omit<T, "getValuePath">>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<Omit<T, "getValuePath">>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<Omit<T, "getValuePath">>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<Omit<T, "getValuePath">>, nextState: Readonly<{}>, nextContext: any): void;
    };
    displayName: string;
    contextTypes: {
        getValuePath: PropTypes.Requireable<any>;
    };
    contextType?: React.Context<any>;
};
//# sourceMappingURL=withValuePath.d.ts.map