"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AlertStrip = AlertStrip;
var _icons = require("@sanity/icons");
var _ui = require("@sanity/ui");
var _react = _interopRequireDefault(require("react"));
var _Details = require("./components/Details");
var _excluded = ["children", "status", "title"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var STATUS_TONES = {
  warning: 'caution',
  error: 'critical',
  info: 'positive'
};
var STATUS_ICONS = {
  warning: /*#__PURE__*/_react.default.createElement(_icons.WarningOutlineIcon, null),
  error: /*#__PURE__*/_react.default.createElement(_icons.ErrorOutlineIcon, null),
  info: /*#__PURE__*/_react.default.createElement(_icons.InfoOutlineIcon, null)
};
function AlertStrip(props) {
  var children = props.children,
    _props$status = props.status,
    status = _props$status === void 0 ? 'warning' : _props$status,
    title = props.title,
    rest = _objectWithoutProperties(props, _excluded);
  return /*#__PURE__*/_react.default.createElement(_ui.Card, _extends({
    radius: 2,
    tone: STATUS_TONES[status]
  }, rest, {
    "data-ui": "Alert"
  }), /*#__PURE__*/_react.default.createElement(_ui.Flex, {
    padding: 1
  }, children && /*#__PURE__*/_react.default.createElement(_ui.Box, {
    flex: 1
  }, /*#__PURE__*/_react.default.createElement(_Details.Details, {
    icon: STATUS_ICONS[status],
    title: title
  }, /*#__PURE__*/_react.default.createElement(_ui.Box, {
    marginLeft: 3,
    marginTop: 3
  }, children)))));
}