"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _autoId = require("@reach/auto-id");
var _ui = require("@sanity/ui");
var _components = require("@sanity/base/components");
var _internal = require("@sanity/base/_internal");
var _changeIndicators = require("@sanity/base/change-indicators");
var _presence = require("@sanity/base/presence");
var _PatchEvent = _interopRequireWildcard(require("../PatchEvent"));
var _templateObject, _templateObject2;
/* eslint-disable import/no-unresolved */
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var CenterAlignedBox = (0, _styledComponents.default)(_ui.Box)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  align-self: center;\n"])));
var ZeroLineHeightBox = (0, _styledComponents.default)(_ui.Box)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  line-height: 0;\n"])));
var BooleanInput = /*#__PURE__*/_react.default.forwardRef(function BooleanInput(props, ref) {
  var _type$options;
  var onChange = props.onChange;
  var value = props.value,
    type = props.type,
    readOnly = props.readOnly,
    onFocus = props.onFocus,
    markers = props.markers,
    presence = props.presence;
  var layout = ((_type$options = type.options) === null || _type$options === void 0 ? void 0 : _type$options.layout) || 'switch';
  var inputId = (0, _autoId.useId)();
  var handleChange = (0, _react.useCallback)(event => {
    onChange(_PatchEvent.default.from((0, _PatchEvent.set)(event.currentTarget.checked)));
  }, [onChange]);
  var indeterminate = typeof value !== 'boolean';
  var checked = value || false;
  var LayoutSpecificInput = layout === 'checkbox' ? _ui.Checkbox : _ui.Switch;
  return /*#__PURE__*/_react.default.createElement(_changeIndicators.ChangeIndicator, null, /*#__PURE__*/_react.default.createElement(_ui.Card, {
    border: true,
    radius: 1
  }, /*#__PURE__*/_react.default.createElement(_ui.Flex, null, /*#__PURE__*/_react.default.createElement(ZeroLineHeightBox, {
    padding: 3
  }, /*#__PURE__*/_react.default.createElement(LayoutSpecificInput, {
    id: inputId,
    ref: ref,
    label: type.title,
    readOnly: Boolean(readOnly),
    onChange: handleChange,
    onFocus: onFocus,
    indeterminate: indeterminate,
    checked: checked,
    style: {
      margin: -4
    },
    disabled: readOnly
  })), /*#__PURE__*/_react.default.createElement(_ui.Box, {
    flex: 1,
    paddingY: 3
  }, /*#__PURE__*/_react.default.createElement(_components.FormFieldHeaderText, {
    description: type.description,
    inputId: inputId,
    __unstable_markers: markers,
    title: type.title
  })), /*#__PURE__*/_react.default.createElement(CenterAlignedBox, {
    paddingX: 3,
    paddingY: 1
  }, /*#__PURE__*/_react.default.createElement(_internal.FieldStatus, {
    maxAvatars: 1,
    position: "top"
  }, /*#__PURE__*/_react.default.createElement(_presence.FieldPresence, {
    maxAvatars: 1,
    presence: presence
  }))))));
});
var _default = BooleanInput;
exports.default = _default;