"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GroupTab = exports.GroupOption = void 0;
var _react = _interopRequireWildcard(require("react"));
var _ui = require("@sanity/ui");
var _excluded = ["onClick", "parent", "hidden"],
  _excluded2 = ["name", "title"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var GroupTab = /*#__PURE__*/(0, _react.forwardRef)(function GroupTab(props, ref) {
  var name = props.name,
    title = props.title;
  // Separate props for resolving conditional hidden groups
  var onClick = props.onClick,
    parent = props.parent,
    hidden = props.hidden,
    group = _objectWithoutProperties(props, _excluded);

  // Here goes the content of our component
  var handleClick = _react.default.useCallback(() => {
    onClick(name);
  }, [name, onClick]);
  if (hidden) {
    return null;
  }
  return /*#__PURE__*/_react.default.createElement(_ui.Tab, _extends({
    "data-testid": "group-tab-".concat(name),
    size: 1,
    id: "".concat(name, "-tab"),
    label: title || name,
    title: title || name,
    onClick: handleClick
  }, group, {
    ref: ref
  }));
});
exports.GroupTab = GroupTab;
var GroupOption = props => {
  var name = props.name,
    title = props.title,
    rest = _objectWithoutProperties(props, _excluded2);
  // Separate props for resolving conditional hidden groups
  var selected = props.selected,
    hidden = props.hidden;
  if (hidden) {
    return null;
  }
  return /*#__PURE__*/_react.default.createElement("option", {
    title: title,
    value: name,
    id: "".concat(name, "-tab"),
    "aria-controls": rest['aria-controls'],
    "data-testid": "group-select-".concat(name),
    "aria-selected": selected ? 'true' : 'false'
  }, title || name);
};
exports.GroupOption = GroupOption;