"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.VisibleOnFocusButton = VisibleOnFocusButton;
var _ui = require("@sanity/ui");
var _react = _interopRequireDefault(require("react"));
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _templateObject;
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var Root = (0, _styledComponents.default)(_ui.Button)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  position: absolute;\n  z-index: ", ";\n  margin: 1px;\n\n  &:not(:focus) {\n    height: 1px;\n    width: 1px;\n    overflow: hidden;\n    clip: rect(1px, 1px, 1px, 1px);\n  }\n"])), _ref => {
  var $zIndex = _ref.$zIndex;
  return $zIndex;
});
function VisibleOnFocusButton(props) {
  var children = props.children,
    onClick = props.onClick;
  var _useLayer = (0, _ui.useLayer)(),
    zIndex = _useLayer.zIndex;
  return /*#__PURE__*/_react.default.createElement(Root, {
    mode: "ghost",
    onClick: onClick,
    $zIndex: zIndex + 1
  }, children);
}