"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useObjectEditFormBuilderChange = useObjectEditFormBuilderChange;
var _react = require("react");
// This hook will forward patches to the root onChange from the forms of the embedded objects.
function useObjectEditFormBuilderChange(onChange) {
  var onObjectEditFormBuilderChange = (0, _react.useCallback)((patchEvent, path) => {
    var prefixedEvent = patchEvent;
    path.slice(0).reverse().forEach(segment => {
      prefixedEvent = prefixedEvent.prefixAll(segment);
    });
    onChange(prefixedEvent);
  }, [onChange]);
  return (0, _react.useMemo)(() => ({
    onObjectEditFormBuilderChange
  }), [onObjectEditFormBuilderChange]);
}