"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSpellcheck = useSpellcheck;
var _portableTextEditor = require("@sanity/portable-text-editor");
var _react = require("react");
function useSpellcheck() {
  var editor = (0, _portableTextEditor.usePortableTextEditor)();
  return (0, _react.useMemo)(() => {
    var _editor$portableTextF;
    // Chrome 96. has serious perf. issues with spellchecking
    // https://bugs.chromium.org/p/chromium/issues/detail?id=1271918
    // This issue is verified fixed in Chrome 97.
    var spellCheckOption = (_editor$portableTextF = editor.portableTextFeatures.types.block.options) === null || _editor$portableTextF === void 0 ? void 0 : _editor$portableTextF.spellCheck;
    var isChrome96 = typeof navigator === 'undefined' ? false : /Chrome\/96/.test(navigator.userAgent);
    return spellCheckOption === undefined && isChrome96 === true ? false : spellCheckOption;
  }, [editor]);
}