"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getModalOption = getModalOption;
var _get2 = _interopRequireDefault(require("lodash/get"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function getModalOption(opts) {
  var type = opts.type;
  var legacyEditModalOption = (0, _get2.default)(type, 'options.editModal');
  var modalOption = (0, _get2.default)(type, 'options.modal') || {};
  if (legacyEditModalOption) {
    console.warn('The "editModal" option will be deprecated. Please use `options.modal.type` instead.');
  }
  var modalType = modalOption.type || legacyEditModalOption;
  if (modalType === 'fullscreen') {
    return {
      type: 'dialog',
      width: 'full'
    };
  }
  if (modalType === 'fold') {
    modalType = 'popover';
  }
  return {
    type: modalType,
    width: modalOption.width
  };
}