"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Decorator = Decorator;
var _react = _interopRequireDefault(require("react"));
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _constants = require("./constants");
var _templateObject;
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var Root = _styledComponents.default.span(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  /* Make sure the annotation styling is visible */\n  &[data-mark='code'] {\n    mix-blend-mode: multiply;\n    color: inherit;\n  }\n"])));
function Decorator(props) {
  var mark = props.mark,
    children = props.children;
  var tag = _constants.TEXT_DECORATOR_TAGS[mark];
  return /*#__PURE__*/_react.default.createElement(Root, {
    as: tag,
    "data-mark": mark
  }, children);
}