"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TagsArrayInput = void 0;
var _react = _interopRequireWildcard(require("react"));
var _components = require("@sanity/base/components");
var _autoId = require("@reach/auto-id");
var _tagInput = require("../components/tagInput");
var _PatchEvent = _interopRequireWildcard(require("../PatchEvent"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var TagsArrayInput = /*#__PURE__*/(0, _react.forwardRef)(function TagsArrayInput(props, ref) {
  var level = props.level,
    markers = props.markers,
    onChange = props.onChange,
    onFocus = props.onFocus,
    presence = props.presence,
    readOnly = props.readOnly,
    type = props.type,
    _props$value = props.value,
    value = _props$value === void 0 ? [] : _props$value;
  var id = (0, _autoId.useId)();
  var tagInputValue = (0, _react.useMemo)(() => value.map(v => ({
    value: v
  })), [value]);
  var inputRef = (0, _react.useRef)(null);
  var handleChange = (0, _react.useCallback)(nextValue => {
    var patch = nextValue.length === 0 ? (0, _PatchEvent.unset)() : (0, _PatchEvent.set)(nextValue.map(v => v.value));
    onChange(_PatchEvent.default.from(patch));
  }, [onChange]);
  (0, _react.useImperativeHandle)(ref, () => ({
    focus: () => {
      var _inputRef$current;
      return (_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 ? void 0 : _inputRef$current.focus();
    }
  }));
  return /*#__PURE__*/_react.default.createElement(_components.FormField, {
    level: level,
    title: type.title,
    description: type.description,
    __unstable_presence: presence,
    inputId: id,
    __unstable_markers: markers
  }, /*#__PURE__*/_react.default.createElement(_tagInput.TagInput, {
    id: id,
    onChange: handleChange,
    onFocus: onFocus,
    readOnly: readOnly,
    ref: inputRef,
    value: tagInputValue
  }));
});
exports.TagsArrayInput = TagsArrayInput;