"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RowWrapper = void 0;
var _react = _interopRequireDefault(require("react"));
var _ui = require("@sanity/ui");
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _sortable = require("../../../common/sortable");
var _excluded = ["children"];
var _templateObject;
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var Root = (0, _styledComponents.default)(_ui.Card)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  position: relative;\n  border: 1px solid transparent;\n  .dragHandle {\n    color: var(--card-shadow-umbra-color);\n  }\n  &:hover {\n    border-color: var(--card-shadow-umbra-color);\n    .dragHandle {\n      color: inherit;\n    }\n  }\n  &[aria-selected='true'] {\n    border-color: var(--card-focus-ring-color);\n  }\n  .", " & {\n    box-shadow: 0 0 0 0, 0 8px 17px 2px var(--card-shadow-umbra-color),\n      0 3px 14px 2px var(--card-shadow-penumbra-color),\n      0 5px 5px -3px var(--card-shadow-ambient-color);\n  }\n"])), _sortable.MOVING_ITEM_CLASS_NAME);
var RowWrapper = /*#__PURE__*/_react.default.forwardRef(function RowWrapper(props, ref) {
  var children = props.children,
    rest = _objectWithoutProperties(props, _excluded);
  return /*#__PURE__*/_react.default.createElement(Root, _extends({}, rest, {
    ref: ref,
    tone: props.tone
    /*prevent clicks in children from triggering onFocus on surrounding array input*/,
    tabIndex: -1
  }), children);
});
exports.RowWrapper = RowWrapper;