"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Item = Item;
exports.List = List;
var _ui = require("@sanity/ui");
var _react = _interopRequireDefault(require("react"));
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _sortable = require("./sortable");
var _excluded = ["isSortable", "isGrid", "onSortEnd"],
  _excluded2 = ["isSortable", "isGrid"];
var _templateObject;
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var ListItem = (0, _styledComponents.default)(_ui.Card)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  &.", " {\n    z-index: 10000;\n    border-radius: ", "px;\n    box-shadow: 0 0 0 0, 0 8px 17px 2px var(--card-shadow-umbra-color),\n      0 3px 14px 2px var(--card-shadow-penumbra-color),\n      0 5px 5px -3px var(--card-shadow-ambient-color);\n\n    // Used inside CellItem\n    [data-ui='DragHandleCard'] {\n      opacity: 1;\n    }\n\n    [data-ui='DragHandleButton'] {\n      background-color: ", ";\n      color: ", ";\n      [data-ui='Text'] {\n        color: inherit;\n      }\n    }\n  }\n"])), _sortable.MOVING_ITEM_CLASS_NAME, _ref => {
  var theme = _ref.theme;
  return theme.sanity.radius[2];
}, _ref2 => {
  var theme = _ref2.theme;
  return theme.sanity.color.button.bleed.primary.pressed.bg;
}, _ref3 => {
  var theme = _ref3.theme;
  return theme.sanity.color.button.bleed.primary.pressed.fg;
});
var GridItem = ListItem;
var SortableList = (0, _sortable.sortableList)(_ui.Grid);
var SortableListItem = (0, _sortable.sortableItem)(ListItem);
var SortableGrid = (0, _sortable.sortableGrid)(_ui.Grid);
var SortableGridItem = SortableListItem;
function List(props) {
  var isSortable = props.isSortable,
    isGrid = props.isGrid,
    onSortEnd = props.onSortEnd,
    rest = _objectWithoutProperties(props, _excluded);
  if (isGrid) {
    return isSortable ? /*#__PURE__*/_react.default.createElement(SortableGrid, _extends({
      columns: [2, 3, 4],
      gap: 3,
      onSortEnd: onSortEnd
    }, rest)) : /*#__PURE__*/_react.default.createElement(_ui.Grid, _extends({
      columns: [2, 3, 4],
      gap: 3
    }, rest));
  }
  return isSortable ? /*#__PURE__*/_react.default.createElement(SortableList, _extends({
    gap: 1,
    onSortEnd: onSortEnd
  }, rest)) : /*#__PURE__*/_react.default.createElement(_ui.Grid, _extends({
    gap: 1
  }, rest));
}
function Item(props) {
  var isSortable = props.isSortable,
    isGrid = props.isGrid,
    rest = _objectWithoutProperties(props, _excluded2);
  if (isGrid) {
    var _ItemComponent = isSortable ? SortableGridItem : GridItem;
    return /*#__PURE__*/_react.default.createElement(_ItemComponent, rest);
  }
  var ItemComponent = isSortable ? SortableListItem : ListItem;
  return /*#__PURE__*/_react.default.createElement(ItemComponent, rest);
}