"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ImageActionsMenu = ImageActionsMenu;
var _react = _interopRequireWildcard(require("react"));
var _icons = require("@sanity/icons");
var _ui = require("@sanity/ui");
var _ImageActionsMenu = require("./ImageActionsMenu.styled");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function ImageActionsMenu(props) {
  var onEdit = props.onEdit,
    children = props.children,
    showEdit = props.showEdit,
    isMenuOpen = props.isMenuOpen,
    onMenuOpen = props.onMenuOpen;
  var _useState = (0, _react.useState)(null),
    _useState2 = _slicedToArray(_useState, 2),
    menuElement = _useState2[0],
    setMenuRef = _useState2[1];
  var handleClick = _react.default.useCallback(() => onMenuOpen(true), [onMenuOpen]);
  (0, _ui.useClickOutside)(_react.default.useCallback(() => onMenuOpen(false), [onMenuOpen]), [menuElement]);
  return /*#__PURE__*/_react.default.createElement(_ImageActionsMenu.MenuActionsWrapper, {
    "data-buttons": true,
    space: 1,
    padding: 2
  }, showEdit && /*#__PURE__*/_react.default.createElement(_ImageActionsMenu.ButtonContainer, {
    icon: _icons.EditIcon,
    mode: "ghost",
    onClick: onEdit,
    "data-testid": "options-menu-edit-details"
  }), /*#__PURE__*/_react.default.createElement(_ui.Popover, {
    content: /*#__PURE__*/_react.default.createElement(_ui.Menu, {
      ref: setMenuRef
    }, children),
    portal: true,
    open: isMenuOpen
  }, /*#__PURE__*/_react.default.createElement(_ImageActionsMenu.ButtonContainer, {
    icon: _icons.EllipsisVerticalIcon,
    mode: "ghost",
    "data-testid": "options-menu-button",
    onClick: handleClick
  })));
}