"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ImageInputField = ImageInputField;
var _react = _interopRequireDefault(require("react"));
var PathUtils = _interopRequireWildcard(require("@sanity/util/paths"));
var _FormBuilderInput = require("../../../FormBuilderInput");
var _common = require("../../common");
var _excluded = ["onChange", "field"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function ImageInputField(props) {
  var onChange = props.onChange,
    field = props.field,
    restProps = _objectWithoutProperties(props, _excluded);
  var handleChange = _react.default.useCallback(ev => {
    onChange(ev.prefixAll(field.name));
  }, [onChange, field]);
  return /*#__PURE__*/_react.default.createElement(_common.ConditionalHiddenField, {
    parent: props.parentValue,
    value: props.value,
    hidden: props.field.type.hidden
  }, /*#__PURE__*/_react.default.createElement(_common.ConditionalReadOnlyField, {
    readOnly: props.readOnly,
    value: props.value,
    parent: props.parentValue
  }, /*#__PURE__*/_react.default.createElement(_FormBuilderInput.FormBuilderInput, _extends({}, restProps, {
    type: field.type,
    path: PathUtils.pathFor([field.name]),
    onChange: handleChange
  }))));
}