"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SpinnerWrapper = exports.RatioBox = exports.Overlay = exports.MAX_DEFAULT_HEIGHT = exports.FlexOverlay = void 0;
var _ui = require("@sanity/ui");
var _styledComponents = _interopRequireWildcard(require("styled-components"));
var _templateObject, _templateObject2, _templateObject3, _templateObject4;
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var MAX_DEFAULT_HEIGHT = 30;
exports.MAX_DEFAULT_HEIGHT = MAX_DEFAULT_HEIGHT;
var RatioBox = (0, _styledComponents.default)(_ui.Card)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  position: relative;\n  width: 100%;\n  overflow: hidden;\n  min-height: 3.75rem;\n  max-height: 20rem;\n\n  & > div[data-container] {\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100%;\n    display: flex !important;\n    align-items: center;\n    justify-content: center;\n  }\n\n  & img {\n    max-width: 100%;\n    max-height: 100%;\n  }\n"])));
exports.RatioBox = RatioBox;
var SpinnerWrapper = (0, _styledComponents.default)(_ui.Spinner)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  position: absolute;\n"])));
exports.SpinnerWrapper = SpinnerWrapper;
var Overlay = (0, _styledComponents.default)(_ui.Flex)(_ref => {
  var tone = _ref.tone,
    drag = _ref.drag;
  var textColor = _ui.studioTheme.color.light[tone].card.enabled.fg;
  var backgroundColor = (0, _ui.rgba)(_ui.studioTheme.color.light[tone].card.enabled.bg, 0.8);
  return (0, _styledComponents.css)(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n    position: absolute;\n    top: 0;\n    left: 0;\n    right: 0;\n    bottom: 0;\n    backdrop-filter: ", ";\n    color: ", ";\n    background-color: ", ";\n  "])), drag ? 'blur(10px)' : '', tone ? textColor : '', drag ? backgroundColor : 'transparent');
});
exports.Overlay = Overlay;
var FlexOverlay = (0, _styledComponents.default)(_ui.Flex)(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n"])));
exports.FlexOverlay = FlexOverlay;