"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DropMessage = DropMessage;
var _react = _interopRequireDefault(require("react"));
var _ui = require("@sanity/ui");
var _icons = require("@sanity/icons");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function DropMessage(props) {
  var hoveringFiles = props.hoveringFiles,
    types = props.types,
    resolveUploader = props.resolveUploader;
  var acceptedFiles = hoveringFiles.filter(file => types.some(type => resolveUploader(type, file)));
  var rejectedFilesCount = hoveringFiles.length - acceptedFiles.length;
  var multiple = types.length > 1;
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, acceptedFiles.length > 0 ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_ui.Inline, {
    space: 2
  }, /*#__PURE__*/_react.default.createElement(_ui.Text, null, /*#__PURE__*/_react.default.createElement(_icons.UploadIcon, null)), /*#__PURE__*/_react.default.createElement(_ui.Text, null, "Drop to upload", ' ', multiple && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, acceptedFiles.length, " file", acceptedFiles.length > 1 ? 's' : ''))), rejectedFilesCount > 0 && /*#__PURE__*/_react.default.createElement(_ui.Box, {
    marginTop: 4
  }, /*#__PURE__*/_react.default.createElement(_ui.Inline, {
    space: 2
  }, /*#__PURE__*/_react.default.createElement(_ui.Text, {
    muted: true,
    size: 1
  }, /*#__PURE__*/_react.default.createElement(_icons.AccessDeniedIcon, null)), /*#__PURE__*/_react.default.createElement(_ui.Text, {
    muted: true,
    size: 1
  }, rejectedFilesCount, " file", rejectedFilesCount > 1 ? 's' : '', " can't be uploaded here")))) : /*#__PURE__*/_react.default.createElement(_ui.Inline, {
    space: 2
  }, /*#__PURE__*/_react.default.createElement(_ui.Text, null, /*#__PURE__*/_react.default.createElement(_icons.AccessDeniedIcon, null)), /*#__PURE__*/_react.default.createElement(_ui.Text, null, "Can't upload ", hoveringFiles.length > 1 ? 'any of these files' : 'this file', " here")));
}