"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = resolveReferenceInput;
var _once2 = _interopRequireDefault(require("lodash/once"));
var _SanityReferenceInput = _interopRequireDefault(require("../inputs/reference/SanityReferenceInput"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/* eslint-disable no-console */
var warnInputTypeNotSupported = (0, _once2.default)(() => console.warn('The option "inputType" on references is removed.'));
var warnSearchableOptionNotSupported = (0, _once2.default)(() => console.warn('The option "searchable" on references has been removed.'));

/* eslint-enable no-console */

function resolveReferenceInput(type) {
  var options = type.options || {};
  if (options.inputType) {
    warnInputTypeNotSupported();
  }
  if ('searchable' in options) {
    warnSearchableOptionNotSupported();
  }
  return _SanityReferenceInput.default;
}