"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SanityArrayOfPrimitivesInput = exports.SanityArrayInput = void 0;
var _react = _interopRequireWildcard(require("react"));
var _formBuilder = _interopRequireDefault(require("config:@sanity/form-builder"));
var _functions = _interopRequireDefault(require("part:@sanity/form-builder/input/array/functions"));
var _initialValueTemplates = require("@sanity/initial-value-templates");
var _resolveUploader = _interopRequireDefault(require("../uploads/resolveUploader"));
var _ArrayOfObjectsInput = _interopRequireDefault(require("../../inputs/arrays/ArrayOfObjectsInput"));
var _ArrayOfPrimitivesInput = require("../../inputs/arrays/ArrayOfPrimitivesInput");
var is = _interopRequireWildcard(require("../../utils/is"));
var _SanityArrayItemReferenceInput = _interopRequireDefault(require("./reference/SanityArrayItemReferenceInput"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } // @todo: remove the following line when part imports has been removed from this file
///<reference types="@sanity/types/parts" />
var arrayResolveUploader = (type, file) => {
  var _formBuilderConfig$im, _formBuilderConfig$fi;
  var SUPPORT_DIRECT_IMAGE_UPLOADS = _formBuilder.default === null || _formBuilder.default === void 0 || (_formBuilderConfig$im = _formBuilder.default.images) === null || _formBuilderConfig$im === void 0 ? void 0 : _formBuilderConfig$im.directUploads;
  var SUPPORT_DIRECT_FILE_UPLOADS = _formBuilder.default === null || _formBuilder.default === void 0 || (_formBuilderConfig$fi = _formBuilder.default.files) === null || _formBuilderConfig$fi === void 0 ? void 0 : _formBuilderConfig$fi.directUploads;
  if (is.type('image', type) && !SUPPORT_DIRECT_IMAGE_UPLOADS) {
    return null;
  }
  if (is.type('file', type) && !SUPPORT_DIRECT_FILE_UPLOADS) {
    return null;
  }
  return (0, _resolveUploader.default)(type, file);
};
var SanityArrayInput = /*#__PURE__*/(0, _react.forwardRef)(function SanityArrayInput(props, ref) {
  return /*#__PURE__*/_react.default.createElement(_ArrayOfObjectsInput.default, _extends({}, props, {
    ref: ref,
    ReferenceItemComponent: _SanityArrayItemReferenceInput.default,
    resolveUploader: arrayResolveUploader,
    resolveInitialValue: _initialValueTemplates.resolveInitialValueForType,
    ArrayFunctionsImpl: _functions.default
  }));
});
exports.SanityArrayInput = SanityArrayInput;
var SanityArrayOfPrimitivesInput = /*#__PURE__*/(0, _react.forwardRef)(function SanityArrayOfPrimitivesInput(props, ref) {
  return /*#__PURE__*/_react.default.createElement(_ArrayOfPrimitivesInput.ArrayOfPrimitivesInput, _extends({}, props, {
    ArrayFunctionsImpl: _functions.default,
    ref: ref
  }));
});
exports.SanityArrayOfPrimitivesInput = SanityArrayOfPrimitivesInput;