"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _operators = require("rxjs/operators");
var _patches = require("../../patch/patches");
var _uploadImage = _interopRequireDefault(require("./uploadImage"));
var _uploadFile = _interopRequireDefault(require("./uploadFile"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var UPLOAD_IMAGE = {
  type: 'image',
  accepts: 'image/*',
  upload: (file, type, options) => (0, _uploadImage.default)(file, options)
};
var UPLOAD_FILE = {
  type: 'file',
  accepts: '',
  upload: (file, type, options) => (0, _uploadFile.default)(file, options)
};
var UPLOAD_TEXT = {
  type: 'string',
  accepts: 'text/*',
  upload: (file, type, options) => (0, _uploadFile.default)(file, options).pipe((0, _operators.map)(content => ({
    type: 'uploadEvent',
    patches: [(0, _patches.set)(content)]
  })))
  // Todo: promote this to a "first-class" form-builder abstraction
  // and make it possible to register custom uploaders
};

var uploaders = [UPLOAD_IMAGE, UPLOAD_TEXT, UPLOAD_FILE].map((uploader, i) => _objectSpread(_objectSpread({}, uploader), {}, {
  priority: i
}));
var _default = uploaders;
exports.default = _default;