"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PreviewAny = PreviewAny;
var _react = _interopRequireDefault(require("react"));
var _PreviewPrimitive = require("./PreviewPrimitive");
var _PreviewObject = require("./PreviewObject");
var _PreviewArray = require("./PreviewArray");
var _excluded = ["value"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var NO_VALUE = /*#__PURE__*/_react.default.createElement(_PreviewPrimitive.PreviewPrimitive, {
  value: "<no value>"
});
function PreviewAny(props) {
  var value = props.value,
    rest = _objectWithoutProperties(props, _excluded);
  switch (typeof value) {
    case 'number':
    case 'boolean':
    case 'string':
      {
        return /*#__PURE__*/_react.default.createElement(_PreviewPrimitive.PreviewPrimitive, _extends({}, rest, {
          value: value
        }));
      }
    case 'undefined':
      {
        return NO_VALUE;
      }
    case 'object':
      {
        if (value === null) {
          return NO_VALUE;
        }
        if (Array.isArray(value)) {
          return /*#__PURE__*/_react.default.createElement(_PreviewArray.PreviewArray, _extends({}, rest, {
            value: value
          }));
        }
        return /*#__PURE__*/_react.default.createElement(_PreviewObject.PreviewObject, _extends({}, rest, {
          value: value
        }));
      }
    default:
      {
        return /*#__PURE__*/_react.default.createElement("span", null, '<unknown>');
      }
  }
}